<?php

if ( ! defined( 'ABSPATH' ) ) exit;

//register plugin field settings
add_action( 'admin_init', 'dvs_rgs_plugin_settings' );
function dvs_rgs_plugin_settings() {
	register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_enable' );	
    register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_email' );
    register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_password' );
    register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_type' );     
    register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_handling' );           
	register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_consignee' );
    register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_product' );	      
    register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_remarks' );
    register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_product_check' );     
    register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_sku_check' );
    register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_notes_check' );
    register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_pieces_check' );    
    register_setting( 'dvs-rgs-settings-group', 'dvs_rgs_cod_check' );   
}

//Courier settings input fields
function dvs_rgs_api_page() { ?>

<div class="wrap">
<form method="post" action="options.php">
    <?php 
	settings_fields( 'dvs-rgs-settings-group' );
	do_settings_sections( 'dvs-rgs-settings-group' );
	$dvs_rgs_type = get_option('dvs_rgs_type');
	$dvs_rgs_handling = get_option('dvs_rgs_handling');
	$dvs_rgs_consignee = get_option('dvs_rgs_consignee');
 	?>
    <img src="<?php echo plugin_dir_url( __DIR__ ) . 'images/rgs-label-logo.png'; ?>" height="50px">
    <h2>RGS Logistics Settings</h2>
    <table class="form-table">

        <tr>
        <th scope="row">Enable RGS Logistics API</th>
        <td>
	    <?php
	    echo '<input type="checkbox" name="dvs_rgs_enable" value="1" ' . checked( 1, get_option( 'dvs_rgs_enable' ), false ) . ' />';?>
        </td>
        </tr> 

        <tr>
        <th scope="row">Email Address</th>
        <td><input class="regular-text" placeholder="" type="text" name="dvs_rgs_email" value="<?php echo esc_attr( get_option('dvs_rgs_email') ); ?>" required/></td>
        </tr>
        <tr>
        <th scope="row">Password</th>
        <td><input class="regular-text" placeholder="" type="password" name="dvs_rgs_password" value="<?php echo esc_attr( get_option('dvs_rgs_password') ); ?>" required /></td>
        </tr>

        <?php

        $get_dvs_rgs_email = get_option('dvs_rgs_email');
        $get_dvs_rgs_password = get_option('dvs_rgs_password');

        if (!empty($get_dvs_rgs_email) && !empty($get_dvs_rgs_password) ) {


            $curl = curl_init();
            curl_setopt_array($curl, array(
              CURLOPT_URL => 'https://codsolution.co/ship/Api/loginApi?email='.urlencode($get_dvs_rgs_email).'&password='.urlencode($get_dvs_rgs_password),
              CURLOPT_RETURNTRANSFER => true,
              CURLOPT_ENCODING => '',
              CURLOPT_MAXREDIRS => 10,
              CURLOPT_TIMEOUT => 60,
              CURLOPT_FOLLOWLOCATION => true,
              CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
              CURLOPT_CUSTOMREQUEST => 'POST',
              CURLOPT_HTTPHEADER => array(),
            ));
            $response = curl_exec($curl);
            curl_close($curl);

            $result = json_decode($response, true);

            if($result['status'] == 'success') { ?>	        

                <tr>
                <th scope="row">Shipment Type</th>
                <td>
                    <select id="dvs_rgs_type" name="dvs_rgs_type" required>
                    	<option value="1" <?php selected($dvs_rgs_type,'1'); ?>>COD</option>
                        <option value="5" <?php selected($dvs_rgs_type,'5'); ?>>JNT</option>
                        <option value="3" <?php selected($dvs_rgs_type,'3'); ?>>ARAMEX</option>
						<option value="9" <?php selected($dvs_rgs_type,'9'); ?>>IMile</option>
						<option value="10" <?php selected($dvs_rgs_type,'10'); ?>>TFM</option>
						<option value="11" <?php selected($dvs_rgs_type,'11'); ?>>Naqel</option>
                    </select>
                <td>        
                </tr>

                <tr>
                <th scope="row">Shipment Handling</th>
                <td>
                    <select id="dvs_rgs_handling" name="dvs_rgs_handling" required>
                    	<option value="Yes" <?php selected($dvs_rgs_handling,'Yes'); ?>>Fragile</option>
                    </select>
                <td>        
                </tr>        

                <tr>
                <th scope="row">Consginee Details</th>
                <td>
                    <select id="dvs_rgs_consignee" name="dvs_rgs_consignee" required>
                    <option value="Billing Details" <?php selected($dvs_rgs_consignee,'Billing Details'); ?>>Billing Details</option>
                    <option value="Shipping Details" <?php selected($dvs_rgs_consignee,'Shipping Details'); ?>>Shipping Details</option>
                    </select>
                <td>        
                </tr>

                <tr>
                <th scope="row">Default Remarks</th>
                <td><input class="regular-text" placeholder="" type="text" name="dvs_rgs_remarks" value="<?php echo esc_attr( get_option('dvs_rgs_remarks') ); ?>" required/></td>
                </tr>  

                <tr>
                <th scope="row">Default Product</th>
                <td><input class="regular-text" placeholder="" type="text" name="dvs_rgs_product" value="<?php echo esc_attr( get_option('dvs_rgs_product') ); ?>" /></td>
                </tr>  

                <tr>
                <th scope="row">Print Item Name in Label</th>
                <td>
                <?php
                echo '<input type="checkbox" name="dvs_rgs_product_check" value="1" ' . checked( 1, get_option( 'dvs_rgs_product_check' ), false ) . ' />';?>
                </td>
                </tr>

                <tr>
                <th scope="row">Print SKU Name in Label</th>
                <td>
                <?php
                echo '<input type="checkbox" name="dvs_rgs_sku_check" value="1" ' . checked( 1, get_option( 'dvs_rgs_sku_check' ), false ) . ' />';?>
                </td>
                </tr>     

                <tr>
                <th scope="row">Print Order Notes in Remarks</th>
                <td>
                <?php
                echo '<input type="checkbox" name="dvs_rgs_notes_check" value="1" ' . checked( 1, get_option( 'dvs_rgs_notes_check' ), false ) . ' />';?>
                </td>
                </tr>  

                <tr>
                <th scope="row">Auto Calculate Pieces</th>
                <td>
                <?php
                echo '<input type="checkbox" name="dvs_rgs_pieces_check" value="1" ' . checked( 1, get_option( 'dvs_rgs_pieces_check' ), false ) . ' />';?>
                </td>
                </tr>           

                <tr>
                <th scope="row">Calculate Non-COD as Zero</th>
                <td>
                <?php
                echo '<input type="checkbox" name="dvs_rgs_cod_check" value="1" ' . checked( 1, get_option( 'dvs_rgs_cod_check' ), false ) . ' />';?>
                </td>
                </tr>
                
            <?php
                }
            else {
                echo '<div class="notice notice-error is-dismissible"><p>Error: Invalid Email address or Password</p><hr>Response: '.$response.'</div>';
            }
        }
        ?>

    </table>

    <?php 	
	submit_button('Submit'); 
	?>
</form>

<br>
<a href="https://www.youtube.com/watch?v=cBXVH5qtgOc" target="blank" class="woocommerce-Button button" style="display:none">Video: How to configure rgs Courier Settings</a>
<br>
<br>
<a href="https://devsol.pk/contact/" target="blank" class="woocommerce-Button button">Get Support</a>
<br>
<br>
<a href="https://wa.me/9203234152099" target="blank" class="woocommerce-Button button">WhatsApp Support</a>

</div>

<?php 
}


function dvs_rgs_orders_data($order_id) {
    $order = wc_get_order($order_id);
    foreach ($order->get_items() as $item_key => $item ) {
        $order_product = $item->get_product();
        $orders_items[] = array(
            'item_name' => $item['name'],
            'item_qty' => $item['qty'],
            'item_sku'    => $order_product ? $order_product->get_sku() : '',
            'item_weight' => $order_product ? $order_product->get_weight() : '',
            'item_status' => $order_product ? $order_product->get_status() : '',
        );
    }

    $orders_data = array(
        'status' => $order->get_meta('_dvs_courier_check'),
        'order_id' => $order->get_id(),
        'order_number' => $order->get_order_number(),
        'gateway' => $order->get_payment_method(),
        'amount' => $order->get_total(),
        'email' => $order->get_billing_email(),
        'notes' => $order->get_customer_note(),
        'billing_name' => $order->get_billing_first_name() . ' ' . $order->get_billing_last_name(),
        'billing_address' => $order->get_billing_address_1() . ' ' . $order->get_billing_address_2(),
        'billing_city' => $order->get_billing_city(),
        'billing_phone' => $order->get_billing_phone(),
        'shipping_name' => $order->get_shipping_first_name() . ' ' . $order->get_shipping_last_name(),
        'shipping_address' => $order->get_shipping_address_1() . ' ' . $order->get_shipping_address_2(),
        'shipping_city' => $order->get_shipping_city(),
        'shipping_phone' => get_post_meta($order->get_id(), '_shipping_phone', true),
        'orders_items' => $orders_items,
    );

    return $orders_data;
}



function dvs_rgs_body_data($orders_data) {
    $response = [
        'orders' => $orders_data,
        'dvs_courier' => 'RGS Logistics',
        'dvs_slug' => 'rgs',
        'dvs_rgs_email' => get_option('dvs_rgs_email'),
        'dvs_rgs_password'  =>  get_option('dvs_rgs_password'),        
        'dvs_type' => get_option( 'dvs_rgs_type' ),
        'dvs_handling' => get_option( 'dvs_rgs_handling' ),
        'dvs_consignee' => get_option( 'dvs_rgs_consignee' ),
        'dvs_remarks' => get_option( 'dvs_rgs_remarks' ),
        'dvs_product' => get_option( 'dvs_rgs_product' ),
        'dvs_product_check' => get_option( 'dvs_rgs_product_check' ),
        'dvs_sku_check' => get_option( 'dvs_rgs_sku_check' ),
        'dvs_notes_check' => get_option( 'dvs_rgs_notes_check' ),
        'dvs_weight_check' => get_option( 'dvs_rgs_weight_check' ), 
        'dvs_pieces_check' => get_option( 'dvs_rgs_pieces_check' ),
        'dvs_cod_check' => get_option( 'dvs_rgs_cod_check' ),
    ];
    $body = json_encode($response, true);
    $url = get_option( 'dvs_url' ).'/woo/form.php';
    $output = wp_remote_post( $url, array('method'=> 'POST','sslverify' => false,'timeout'=> 300,'body'=> $body));
    if (is_wp_error($output)) {
        $error = $output->get_error_message();
        echo "Error: $error";
    }
    else {
        $json = $output['body'];
        echo $json;
    }
}


add_filter( 'bulk_actions-edit-shop_order', 'rgs_bulk_actions',101 );
function rgs_bulk_actions( $bulk_array ) {
    $dvs_rgs_enable = get_option( 'dvs_rgs_enable' );
    if ($dvs_rgs_enable == 1 ) {
        $bulk_array['mark_rgs_orders'] = 'RGS Logistics Bulk Booking';
    }
    return $bulk_array;
}


add_filter( 'handle_bulk_actions-edit-shop_order', 'dvs_rgs_bulk_action_handler', 9999, 4 );
function dvs_rgs_bulk_action_handler( $redirect, $doaction, $object_ids ) {
    if ( $doaction !== 'mark_rgs_orders' ) {
        return $redirect;
    }
    $orders_data = [];
    $orders_items = [];
    foreach( $object_ids as $order_id ) {
        $orders_data[] = dvs_rgs_orders_data($order_id);

    }
    dvs_rgs_body_data($orders_data);
}


add_action('woocommerce_order_actions', 'rgs_single_order_action', 10, 1 );
function rgs_single_order_action( $actions ) {
    $dvs_rgs_enable = get_option( 'dvs_rgs_enable' );
    if ($dvs_rgs_enable == 1 ) {    
        if ( is_array( $actions ) ) {
            $actions['rgs_action'] = __( 'Book at RGS Logistics' );
        }
    }
    return $actions;
}


add_action( 'woocommerce_order_action_rgs_action', 'rgs_single_order_booking' );
function rgs_single_order_booking($order_id) {
    $orders_data = [];
    $orders_items = [];    
    $orders_data[] = dvs_rgs_orders_data($order_id);
    dvs_rgs_body_data($orders_data);
    die();
}


add_action( 'init', 'rgs_submit_form' );
function rgs_submit_form() {    
    if(!empty($_POST['dvs_courier']) && $_POST['dvs_courier'] == 'rgs' ) {

        $orders = $_POST['order'];
        $trackings = [];
        $msgs = '';
        $count = 0;
        $uncount = 0;
        $actualcount = 0;       
        $allcount = 1;

        foreach($orders as $order) {

            if(!isset($order['check']))
            continue;

            $book_packet_array = array(
                'dvs_courier' => "RGS",
                'dvs_rgs_email' => get_option('dvs_rgs_email'),
                'dvs_rgs_password'  =>  get_option('dvs_rgs_password'),
                'order' => $order,
            );

            $booking = json_encode($book_packet_array);

            $url = get_option( 'dvs_url' ).'/woo/upload.php';
            $output = wp_remote_post( $url, array('method'=> 'POST','sslverify' => false,'timeout'=> 300,'body'=> $booking));
            if ( is_wp_error( $output ) ) {
                $error = $output->get_error_message();
                echo "Error: $error";
            }
            else {
                $json = $output['body'];
                $response = json_decode($json,true);
            }

            $order_id = $order['order_id'];
            $order_number = $order['order_number'];  
            $current_order = $order;

            // echo $json;
            // die();

            if(!empty($response['shipment_number'])) {
                $order = new WC_Order($order_id);
                $rgs_tracking = $response['shipment_number'];
                $msgs .= "<div style='background-color:#107f61; color:#ffffff; padding:5px 10px; border: 1px solid #107f61; border-radius: 5px; margin: 5px 0px';><strong>{$allcount}: </strong>Order # ".$order_number;
                $msgs .= "<span> [ Booked: ".$rgs_tracking." ]</span></div>";
                $order->add_order_note("Order has been booked at RGS Logistics with Tracking # ".$rgs_tracking);
                update_post_meta( $order->get_id(), '_dvs_courier_list', 'RGS Logistics');   
                update_post_meta( $order->get_id(), '_dvs_courier_tracking', $rgs_tracking );
                update_post_meta( $order->get_id(), '_dvs_courier_check', 'Booked' );

                $dvs_courier_link = 'https://rgslogistics.co/index.php';
                update_post_meta( $order->get_id(), '_dvs_courier_link', $dvs_courier_link ); 

                $dvs_label_shipper_booked = get_option('dvs_label_shipper_booked');

                if($dvs_label_shipper_booked == 1) {
                    $order->update_status( 'wc-booked' );
                }

                // Add log to db
                dvs_ucp_logs($current_order, $rgs_tracking, 'RGS Logistics');
                $trackings[] = $rgs_tracking;
         
                $count++;
            }
            else {
                $msgs .= "<div style='background-color:#ff4e4e; color:#ffffff; padding:5px 10px; border: 1px solid #ff4e4e; border-radius: 5px; margin: 5px 0px';'><strong>{$allcount}: </strong>Order # ".$order_number;
                $msgs .= "<br><span> [ Error: ".$json." ]</span></div>";
                $uncount++;
            }
            $allcount++;
            $actualcount++;
        }   

        if($msgs!='') { ?>

        <style>
        @import url('https://fonts.googleapis.com/css2?family=Roboto&display=swap');

        h3 {
            text-align: center;
        }

        .dvs-booking-result {
            width: 600px;
            margin: 0 auto;
            font-family: 'Roboto', sans-serif;
            margin-top: 20px;
        }               

        .dvs-btn-back {
            float: right;
            margin: 10px 0px;
            border: 1px solid #107f61;
            border-radius: 5px;
            padding: 10px 20px;
            text-align: center;
            text-decoration: none;
            background-color: #ffffff;
            color: #107f61;
            font-size: 16px;        
        }

        .dvs-btn-print {
            float: left;
            margin: 10px 0px;
            border: 1px solid #107f61;
            border-radius: 5px;
            padding: 10px 20px;
            text-align: center;
            text-decoration: none;
            background-color: #107f61;
            color: #ffffff;
            font-size: 16px;        
        }   

        </style>

        <?php
            echo '<div class="dvs-booking-result">';?>
            <center>    
            <img src="<?php echo plugin_dir_url( __DIR__ ) . 'images/rgs-label-logo.png'; ?>" height="50px">    
            <h3>RGS Logistics Booking Summary</h3>
            </center>
            <?php 
            echo "Booked Packets = {$count}";
            echo '<br/>';
            echo '<br/>';       
            echo "Un-Booked Packets = {$uncount}";
            echo '<br/>';
            echo '<br/>';
            echo $msgs;
            echo '<br/>';
            echo '<br/>';

            if($_SERVER['REQUEST_URI'] == '/wp-admin/post.php') {
                $btn_url = get_admin_url(null, 'post.php?post='.$order_id.'&action=edit');
            }
            else {
                $btn_url = get_admin_url(null, 'edit.php?post_type=shop_order');
            }
            $tracking_url = get_admin_url(null, 'edit.php?dvs_trackings=' . join(',', $trackings));

            $dvs_label_shipper_enable = get_option('dvs_label_shipper_enable');

            if ($dvs_label_shipper_enable == '1') {
                echo '<a href="'.$tracking_url.'" class="dvs-btn-print" target="blank">Print Label</a>';
            }
            
            echo '<a href="'.$btn_url.'" class="dvs-btn-back">Go Back</a>';
            echo '</div>';
        }

        $dvs_courier_total = get_option( 'dvs_courier_total' ) + $count;
        update_option('dvs_courier_total', $dvs_courier_total);

        $dvs_courier_rgs = get_option( 'dvs_courier_rgs' ) + $count ;
        update_option('dvs_courier_rgs', $dvs_courier_rgs);

        $url = get_option( 'dvs_url' )."/woo/count.php";
        $data_count = array(
            'dvs_courier' => 'rgs',
            'count' => $actualcount,
            'booked' => $count,
            'unbooked' => $uncount,
        );
        $data_count = json_encode($data_count);
        $post = wp_remote_post( $url, array('method'=> 'POST','sslverify' => false,'timeout'=> 30, 'body'=> $data_count ));
        die();   
    }
}
